/* File: gosiv_path.h

* Copyright (c) 2003 James A. Strother
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*/

#ifndef _GOSIV_PATH_H
#define _GOSIV_PATH_H

#include <queue>
using namespace std;

#include "gosiv_types.h"

class gosiv_path
{
  enum
    {
      GOSIV_PATH_OP,
      GOSIV_PATH_PT
    };

  struct gosiv_node
  {
    int   type;
    void* ptr;
  };

 public:
  gosiv_path();
  ~gosiv_path();

  void         push(int);  
  int          popOp();

  void         push(const gosiv_point&);
  gosiv_point  popPt();

  bool         empty();

 private:
  queue<gosiv_node> q;

};

#endif
