/* File: extrema.c 
 
* Copyright (c) 2002 James A. Strother 
* 
* This program is free software; you can redistribute it and/or modify 
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 2 of the License, or 
* (at your option) any later version. 
* 
* This program is distributed in the hope that it will be useful, 
* but WITHOUT ANY WARRANTY; without even the implied warranty of 
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
* GNU General Public License for more details. 
* 
* You should have received a copy of the GNU General Public License 
* along with this program; if not, write to the Free Software 
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
* 
*/ 
 
#include "osiv.h" 
 
osiv_intf OsivGetMinInd_IMCP (osiv_imcp* array, 
			      osiv_intf len) 
{ 
  register osiv_intf i; 
  register osiv_intf best; 
 
  best = 0; 
  for (i = 1; i < len; i++) 
    if (*(array+best) >= *(array+i)) 
      best = i; 
 
  return best; 
} 
 
osiv_intf OsivGetMinInd_IMSP (osiv_imsp* array, 
			      osiv_intf len) 
{ 
  register osiv_intf i; 
  register osiv_intf best; 
 
  best = 0; 
  for (i = 1; i < len; i++) 
    if (*(array+best) >= *(array+i)) 
      best = i; 
 
  return best; 
} 
 
osiv_intf OsivGetMinInd_IMMP (osiv_immp* array, 
			      osiv_intf len) 
{ 
  register osiv_intf i = 0; 
  register osiv_intf best = 0; 
  osiv_immp lastval = *(array+len-1); 
 
  *(array+len-1) = 0; 
  while (i < len-1) 
    { 
      best = i++;  
      while (*(array+i) > *(array+best)) i++; 
    } 
  *(array+len-1) = lastval; 
 
  if (*(array+best) >= lastval) return len-1; 
  else return best; 
} 
 
osiv_intw OsivGetMinInd_IMCW (osiv_imcw* array, 
			      osiv_intw len) 
{ 
  register osiv_intw i; 
  register osiv_intw best; 
 
  best = 0; 
  for (i = 1; i < len; i++) 
    if (*(array+best) >= *(array+i)) 
      best = i; 
 
  return best; 
} 
 
osiv_intw OsivGetMinInd_IMSW (osiv_immw* array, 
			      osiv_intw len) 
{ 
  register osiv_intw i; 
  register osiv_intw best; 
 
  best = 0; 
  for (i = 1; i < len; i++) 
    if (*(array+best) >= *(array+i)) 
      best = i; 
 
  return best; 
} 
 
osiv_intw OsivGetMinInd_IMMW (osiv_immw* array, 
			      osiv_intw len) 
{ 
  register osiv_intw i = 0; 
  register osiv_intw best = 0; 
  osiv_immw lastval = *(array+len-1); 
 
  *(array+len-1) = 0; 
  while (i < len-1) 
    { 
      best = i++;  
      while (*(array+i) > *(array+best)) i++; 
    } 
  *(array+len-1) = lastval; 
 
  if (*(array+best) >= lastval) return len-1; 
  else return best; 
} 
 
osiv_intf OsivGetMinInd_IMCF (osiv_imcf* array, 
			      osiv_intf len) 
{ 
  register osiv_intf i; 
  register osiv_intf best; 
 
  best = 0; 
  for (i = 1; i < len; i++) 
    if (*(array+best) >= *(array+i)) 
      best = i; 
 
  return best; 
} 
 
osiv_intf OsivGetMinInd_IMSF (osiv_imsf* array, 
			      osiv_intf len) 
{ 
  register osiv_intf i; 
  register osiv_intf best; 
 
  best = 0; 
  for (i = 1; i < len; i++) 
    if (*(array+best) >= *(array+i)) 
      best = i; 
 
  return best; 
} 
 
osiv_intf OsivGetMinInd_IMMF (osiv_immf* array, 
			      osiv_intf len) 
{ 
  register osiv_intf i = 0; 
  register osiv_intf best = 0; 
  osiv_immf lastval = *(array+len-1); 
 
  *(array+len-1) = 0; 
  while (i < len-1) 
    { 
      best = i++;  
      while (*(array+i) > *(array+best)) i++; 
    } 
  *(array+len-1) = lastval; 
 
  if (*(array+best) >= lastval) return len-1; 
  else return best; 
} 
 
osiv_intf OsivGetMaxInd_IMCP (osiv_imcp* array, 
			      osiv_intf len) 
{ 
  register osiv_intf i; 
  register osiv_intf best; 
 
  best = 0; 
  for (i = 1; i < len; i++) 
    if (*(array+best) <= *(array+i)) 
      best = i; 
   
  return best; 
} 
 
osiv_intf OsivGetMaxInd_IMSP (osiv_imsp* array, 
			      osiv_intf len) 
{ 
  register osiv_intf i; 
  register osiv_intf best; 
 
  best = 0; 
  for (i = 1; i < len; i++) 
    if (*(array+best) <= *(array+i)) 
      best = i; 
 
  return best; 
} 
 
osiv_intf OsivGetMaxInd_IMMP (osiv_immp* array, 
			      osiv_intf len) 
{ 
  register osiv_intf i = 0; 
  register osiv_intf best = 0; 
  osiv_immp lastval = *(array+len-1); 
 
  *(array+len-1) = ~(osiv_immp)0; 
  while (i < len-1) 
    { 
      best = i++; 
      while (*(array+i) < *(array+best)) i++; 
    } 
  *(array+len-1) = lastval; 
 
  if (*(array+best) <= lastval) return len-1; 
  else return best; 
} 
 
osiv_intw OsivGetMaxInd_IMCW (osiv_imcw* array, 
			      osiv_intw len) 
{ 
  register osiv_intw i; 
  register osiv_intw best; 
 
  best = 0; 
  for (i = 1; i < len; i++) 
    if (*(array+best) <= *(array+i)) 
      best = i; 
 
  return best; 
} 
 
osiv_intw OsivGetMaxInd_IMSW (osiv_imsw* array, 
			      osiv_intw len) 
{ 
  register osiv_intw i; 
  register osiv_intw best; 
 
  best = 0; 
  for (i = 1; i < len; i++) 
    if (*(array+best) <= *(array+i)) 
      best = i; 
 
  return best; 
} 
 
osiv_intw OsivGetMaxInd_IMMW (osiv_immw* array, 
			      osiv_intw len) 
{ 
  register osiv_intw i = 0; 
  register osiv_intw best = 0; 
  osiv_immw lastval = *(array+len-1); 
 
  *(array+len-1) = ~(osiv_immw)0; 
  while (i < len-1) 
    { 
      best = i++; 
      while (*(array+i) < *(array+best)) i++; 
    } 
  *(array+len-1) = lastval; 
 
  if (*(array+best) <= lastval) return len-1; 
  else return best; 
} 
 
osiv_intf OsivGetMaxInd_IMCF (osiv_imcf* array, 
			      osiv_intf len) 
{ 
  register osiv_intf i; 
  register osiv_intf best; 
 
  best = 0; 
  for (i = 1; i < len; i++) 
    if (*(array+best) <= *(array+i)) 
      best = i; 
 
  return best; 
} 
 
osiv_intf OsivGetMaxInd_IMSF (osiv_imsf* array, 
			      osiv_intf len) 
{ 
  register osiv_intf i; 
  register osiv_intf best; 
 
  best = 0; 
  for (i = 1; i < len; i++) 
    if (*(array+best) <= *(array+i)) 
      best = i; 
 
  return best; 
} 
 
osiv_intf OsivGetMaxInd_IMMF (osiv_immf* array, 
			      osiv_intf len) 
{ 
  register osiv_intf i = 0; 
  register osiv_intf best = 0; 
  osiv_immf lastval = *(array+len-1); 
 
  *(array+len-1) = ~(osiv_immf)0; 
  while (i < len-1) 
    { 
      best = i++; 
      while (*(array+i) < *(array+best)) i++; 
    } 
  *(array+len-1) = lastval; 
 
  if (*(array+best) <= lastval) return len-1; 
  else return best; 
} 
 
osiv_intw OsivGetMinInd_FFT(fftw_real* array, 
			    osiv_intw xlen, 
			    osiv_intw ylen, 
			    osiv_intw xdisp, 
			    osiv_intw ydisp, 
			    osiv_intw yskip) 
{ 
  register osiv_intw i,j; 
  register osiv_intw best=0; 
 
  /* Perform fast search if possible */ 
  if (xdisp == xlen/2 && ydisp == ylen/2) 
    { 
      for (i=0; i<ylen*yskip; i+=yskip) 
	for (j=i; j<xlen+i; j++) 
	  if (*(array+j) <= *(array+best)) best=j; 
      return best; 
    } 
 
  /* Otherwise look more carefully */ 
  for (i = 0; i <= ydisp; i++) 
    { 
      for (j = i*yskip; j <= xdisp+i*yskip; j++) 
	if (*(array+j) <= *(array+best)) best = j; 
 
      j = xlen-xdisp; 
      for (j += i*yskip; j < xlen+i*yskip; j++) 
	if (*(array+j) <= *(array+best)) best = j; 
    } 
 
  for (i = ylen-ydisp; i < ylen; i++) 
    { 
      for (j = i*yskip; j <= xdisp+i*yskip; j++) 
	if (*(array+j) <= *(array+best)) best = j; 
 
      j = xlen-xdisp; 
      for (j += i*yskip; j < xlen+i*yskip; j++) 
	if (*(array+j) <= *(array+best)) best = j; 
    } 
 
  return best; 
} 
 
osiv_intw OsivGetMaxInd_FFT(fftw_real* array, 
			    osiv_intw xlen, 
			    osiv_intw ylen, 
			    osiv_intw xdisp, 
			    osiv_intw ydisp, 
			    osiv_intw yskip) 
{ 
  register osiv_intw i,j; 
  register osiv_intw best=0; 
 
  /* Perform fast search if possible */ 
  if (xdisp == xlen/2 && ydisp == ylen/2) 
    { 
      for (i=0; i<ylen*yskip; i+=yskip) 
	for (j=i; j<xlen+i; j++) 
	  if (*(array+j) >= *(array+best)) best=j; 
      return best; 
    } 
 
  /* Otherwise look more carefully */ 
  for (i = 0; i <= ydisp; i++) 
    { 
      for (j = i*yskip; j <= xdisp+i*yskip; j++) 
	if (*(array+j) >= *(array+best)) best = j; 
 
      j = xlen-xdisp; 
      for (j += i*yskip; j < xlen+i*yskip; j++) 
	if (*(array+j) >= *(array+best)) best = j; 
    } 
 
  for (i = ylen-ydisp; i < ylen; i++) 
    { 
      for (j = i*yskip; j <= xdisp+i*yskip; j++) 
	if (*(array+j) >= *(array+best)) best = j; 
 
      j = xlen-xdisp; 
      for (j += i*yskip; j < xlen+i*yskip; j++) 
	if (*(array+j) >= *(array+best)) best = j; 
    } 
 
  return best; 
} 
